const express = require('express');
const app = express();
const http = require('http');
const server = http.createServer(app);
const { Server } = require("socket.io");
const SerialPort = require('serialport');
const Readline = require('@serialport/parser-readline');

const io = new Server(server, {
  cors: {
    origin: "http://localhost:8080",
    methods: ["GET", "POST"]
  }
});

const port = new SerialPort('/dev/cu.usbmodem11301', { baudRate: 9600 });
const parser = port.pipe(new Readline({ delimiter: '\n' }));

app.use(express.static(__dirname + '/public'));

app.get('/', (req, res) => {
  res.sendFile(__dirname + '/index.html');
});

io.on('connection', (socket) => {
    console.log('a user connected');
    port.on("open", () => {
        console.log('serial port open');
      });

      parser.on('data', data =>{
        console.log(data);
        socket.emit("data", data);
      });
});

server.listen(3000, () => {
  console.log('listening on *:3000');
});
